import { createElement } from 'react';
import '../utils/useId.js';
import { unstable_useCreateElement } from '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-64f351ca.js';
import { mergeProps } from '../utils/mergeProps.js';
import { b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../chunk-459cc222.js';
import { a as warning } from '../chunk-e555b6ea.js';
import 'react-dom';
import { Portal } from '../Portal/Portal.js';
import '../Hidden/HiddenState.js';
import '../Hidden/Hidden.js';
import '../Dialog/Dialog.js';
import 'body-scroll-lock';
import '../Dialog/DialogState.js';
import '../Rover/RoverState.js';
import 'popper.js';
import '../Popover/PopoverState.js';
import { usePopover } from '../Popover/Popover.js';
import { unstable_useStaticMenu } from './StaticMenu.js';
import './StaticMenuState.js';
import { useMenuState } from './MenuState.js';

function useMenu(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _options = _objectSpread({}, options, {
    unstable_autoFocusOnShow: !options.unstable_parent || options.unstable_parent.orientation !== "horizontal"
  });

  _options = unstable_useOptions("useMenu", _options, htmlProps);
  htmlProps = mergeProps({
    role: "menu"
  }, htmlProps);
  htmlProps = unstable_useStaticMenu(_options, htmlProps);
  htmlProps = usePopover(_options, htmlProps);
  htmlProps = unstable_useProps("useMenu", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(usePopover.__keys, unstable_useStaticMenu.__keys, useMenuState.__keys);
useMenu.__keys = keys;
var Menu = unstable_createComponent({
  as: "div",
  useHook: useMenu,
  useCreateElement: function useCreateElement(type, props, children) {
    process.env.NODE_ENV !== "production" ? warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#wai-aria-roles-states-and-properties-13", "Menu") : void 0;
    var element = unstable_useCreateElement(type, props, children);
    return createElement(Portal, null, element);
  }
});

export { Menu, useMenu };
