import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-64f351ca.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../Button/Button.js';
import '../chunk-459cc222.js';
import '../chunk-e555b6ea.js';
import '../Hidden/HiddenState.js';
import '../Dialog/DialogState.js';
import '../Hidden/HiddenDisclosure.js';
import '../Dialog/DialogDisclosure.js';
import '../Rover/RoverState.js';
import 'popper.js';
import '../Popover/PopoverState.js';
import { useMenuState } from './MenuState.js';
import { usePopoverDisclosure } from '../Popover/PopoverDisclosure.js';

function useMenuDisclosure(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useMenuDisclosure", options, htmlProps);
  var dir = options.placement ? options.placement.split("-")[0] : undefined;
  htmlProps = mergeProps({
    "aria-haspopup": "menu",
    onKeyDown: function onKeyDown(event) {
      if (options.disabled) return;
      var keyMap = {
        ArrowUp: dir === "top" || dir === "bottom" ? options.unstable_last : false,
        ArrowRight: dir === "right" && options.unstable_first,
        ArrowDown: dir === "bottom" || dir === "top" ? options.unstable_first : false,
        ArrowLeft: dir === "left" && options.unstable_first
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (typeof action === "function") {
          event.preventDefault();
          options.show();
          action();
        }
      }
    }
  }, htmlProps);
  htmlProps = usePopoverDisclosure(options, htmlProps);
  htmlProps = unstable_useProps("useMenuDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(usePopoverDisclosure.__keys, useMenuState.__keys);
useMenuDisclosure.__keys = keys;
var MenuDisclosure = unstable_createComponent({
  as: "button",
  useHook: useMenuDisclosure
});

export { MenuDisclosure, useMenuDisclosure };
