import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-64f351ca.js';
import { mergeProps } from '../utils/mergeProps.js';
import { a as _objectWithoutPropertiesLoose, b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../chunk-459cc222.js';
import '../chunk-e555b6ea.js';
import '../Hidden/HiddenState.js';
import '../Dialog/DialogState.js';
import '../chunk-beb7e682.js';
import '../Rover/RoverState.js';
import { useRover } from '../Rover/Rover.js';
import 'popper.js';
import '../Popover/PopoverState.js';
import { useMenuState } from './MenuState.js';

function useMenuItem(_ref, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _ref$unstable_focusab = _ref.unstable_focusable,
      unstable_focusable = _ref$unstable_focusab === void 0 ? true : _ref$unstable_focusab,
      options = _objectWithoutPropertiesLoose(_ref, ["unstable_focusable"]);

  var _options = _objectSpread({
    unstable_focusable: unstable_focusable
  }, options);

  _options = unstable_useOptions("useMenuItem", _options, htmlProps);
  htmlProps = mergeProps({
    role: "menuitem",
    onKeyDown: function onKeyDown(event) {
      var _options2 = _options,
          parent = _options2.unstable_parent,
          hide = _options2.hide,
          placement = _options2.placement;
      if (!parent || !hide || !placement) return;

      var _placement$split = placement.split("-"),
          dir = _placement$split[0];

      var target = event.target;
      var parentIsHorizontal = parent.orientation === "horizontal";
      var isDisclosure = target.getAttribute("aria-haspopup") === "menu";
      var keyMap = {
        ArrowRight: parentIsHorizontal && !isDisclosure ? function () {
          parent.unstable_next();
          hide();
        } : dir === "left" && hide,
        ArrowLeft: parentIsHorizontal && !isDisclosure ? function () {
          parent.unstable_previous();
          hide();
        } : dir === "right" && hide
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (typeof action === "function") {
          event.preventDefault();
          action();
        }
      }
    }
  }, htmlProps);
  htmlProps = useRover(_options, htmlProps);
  htmlProps = unstable_useProps("useMenuItem", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useRover.__keys, useMenuState.__keys);
useMenuItem.__keys = keys;
var MenuItem = unstable_createComponent({
  as: "button",
  useHook: useMenuItem
});

export { MenuItem, useMenuItem };
