import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-64f351ca.js';
import { mergeProps } from '../utils/mergeProps.js';
import { b as _objectSpread } from '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../chunk-459cc222.js';
import '../chunk-e555b6ea.js';
import '../Hidden/HiddenState.js';
import '../Dialog/DialogState.js';
import '../chunk-beb7e682.js';
import '../Rover/RoverState.js';
import '../Rover/Rover.js';
import '../Radio/RadioState.js';
import { unstable_useRadio } from '../Radio/Radio.js';
import 'popper.js';
import '../Popover/PopoverState.js';
import { useMenuState } from './MenuState.js';

function unstable_useMenuItemRadio(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useMenuItemRadio", options, htmlProps);
  var currentValue = options.unstable_values[options.name];

  var setValue = function setValue(value) {
    return options.unstable_update(options.name, value);
  };

  htmlProps = mergeProps({
    role: "menuitemradio",
    onKeyDown: function onKeyDown(event) {
      var _options = options,
          parent = _options.unstable_parent,
          hide = _options.hide,
          placement = _options.placement;
      if (!parent || !hide || !placement) return;

      var _placement$split = placement.split("-"),
          dir = _placement$split[0];

      var parentIsHorizontal = parent.orientation === "horizontal";
      var keyMap = {
        ArrowRight: parentIsHorizontal ? function () {
          parent.unstable_next();
          hide();
        } : dir === "left" && hide,
        ArrowLeft: parentIsHorizontal ? function () {
          parent.unstable_previous();
          hide();
        } : dir === "right" && hide
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (typeof action === "function") {
          event.preventDefault();
          action();
        }
      }
    }
  }, htmlProps);
  htmlProps = unstable_useRadio(_objectSpread({}, options, {
    currentValue: currentValue,
    setValue: setValue
  }), htmlProps);
  htmlProps = unstable_useProps("useMenuItemRadio", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(unstable_useRadio.__keys, useMenuState.__keys, ["name"]);
unstable_useMenuItemRadio.__keys = keys;
var unstable_MenuItemRadio = unstable_createComponent({
  as: "input",
  useHook: unstable_useMenuItemRadio
});

export { unstable_MenuItemRadio, unstable_useMenuItemRadio };
