import { createElement } from 'react';
import '../utils/useId.js';
import { unstable_useCreateElement } from '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-64f351ca.js';
import '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-459cc222.js';
import 'react-dom';
import { Portal } from '../Portal/Portal.js';
import '../Hidden/HiddenState.js';
import '../Hidden/Hidden.js';
import '../Dialog/DialogState.js';
import { useDialogBackdrop } from '../Dialog/DialogBackdrop.js';
import 'popper.js';
import { usePopoverState } from './PopoverState.js';

function usePopoverBackdrop(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("usePopoverBackdrop", options, htmlProps);
  htmlProps = useDialogBackdrop(options, htmlProps);
  htmlProps = unstable_useProps("usePopoverBackdrop", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useDialogBackdrop.__keys, usePopoverState.__keys);
usePopoverBackdrop.__keys = keys;
var PopoverBackdrop = unstable_createComponent({
  as: "div",
  useHook: usePopoverBackdrop,
  useCreateElement: function useCreateElement(type, props, children) {
    var element = unstable_useCreateElement(type, props, children);
    return createElement(Portal, null, element);
  }
});

export { PopoverBackdrop, usePopoverBackdrop };
