import 'react';
import '../utils/useId.js';
import '../utils/useCreateElement.js';
import '../system/SystemContext.js';
import '../chunk-64f351ca.js';
import { mergeProps } from '../utils/mergeProps.js';
import '../chunk-397c8002.js';
import { unstable_createComponent } from '../utils/createComponent.js';
import '../system/useToken.js';
import { unstable_useProps } from '../system/useProps.js';
import { unstable_useOptions } from '../system/useOptions.js';
import '../Box/Box.js';
import '../chunk-6e18ef4b.js';
import '../Tabbable/Tabbable.js';
import '../chunk-459cc222.js';
import '../chunk-e555b6ea.js';
import '../chunk-beb7e682.js';
import '../Rover/RoverState.js';
import { useRover } from '../Rover/Rover.js';
import { unstable_useRadioState } from './RadioState.js';

function unstable_useRadio(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = unstable_useOptions("useRadio", options, htmlProps);
  var checked = typeof options.checked !== "undefined" ? options.checked : options.currentValue === options.value;
  htmlProps = mergeProps({
    checked: checked,
    "aria-checked": checked,
    value: options.value,
    role: "radio",
    type: "radio",
    onClick: function onClick(event) {
      if (event.target instanceof HTMLInputElement) return;
      htmlProps.onChange(event);
    },
    onChange: function onChange() {
      if (options.disabled || !options.setValue) return;
      options.setValue(options.value);
    }
  }, htmlProps);
  htmlProps = useRover(options, htmlProps);
  htmlProps = unstable_useProps("useRadio", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(useRover.__keys, unstable_useRadioState.__keys, ["value", "checked"]);
unstable_useRadio.__keys = keys;
var unstable_Radio = unstable_createComponent({
  as: "input",
  useHook: unstable_useRadio
});

export { unstable_Radio, unstable_useRadio };
