'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-6fc382c5.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-eb7a57a2.js');
require('react-dom');
var Portal = require('../Portal/Portal.js');
require('../Hidden/HiddenState.js');
var Hidden = require('../Hidden/Hidden.js');
var DialogState = require('./DialogState.js');

function useDialogBackdrop(options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useDialogBackdrop", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    id: undefined,
    role: undefined,
    style: {
      position: "fixed",
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  }, htmlProps);
  htmlProps = Hidden.useHidden(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useDialogBackdrop", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Hidden.useHidden.__keys, DialogState.useDialogState.__keys);
useDialogBackdrop.__keys = keys;
var DialogBackdrop = createComponent.unstable_createComponent({
  as: "div",
  useHook: useDialogBackdrop,
  useCreateElement: function useCreateElement$1(type, props, children) {
    var element = useCreateElement.unstable_useCreateElement(type, props, children);
    return React.createElement(Portal.Portal, null, element);
  }
});

exports.DialogBackdrop = DialogBackdrop;
exports.useDialogBackdrop = useDialogBackdrop;
