'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-6fc382c5.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_2 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../chunk-2138b837.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
var Checkbox = require('../Checkbox/Checkbox.js');
require('../chunk-eb7a57a2.js');
require('../Checkbox/CheckboxState.js');
require('../chunk-27375ea6.js');
var FormState = require('./FormState.js');
require('./utils/setAllIn.js');
var getIn = require('./utils/getIn.js');
require('./utils/setIn.js');
var __chunk_8 = require('../chunk-0ecca8fe.js');
var __chunk_9 = require('../chunk-a509fd16.js');
var __chunk_10 = require('../chunk-372ca2a7.js');
var __chunk_11 = require('../chunk-3f806342.js');

function unstable_useFormCheckbox(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useFormCheckbox", options, htmlProps);
  var isBoolean = typeof options.value === "undefined";
  var currentValue = getIn.unstable_getIn(options.values, options.name);

  var setValue = function setValue(value) {
    return options.update(options.name, value);
  };

  htmlProps = mergeProps.mergeProps({
    "aria-invalid": __chunk_11.shouldShowError(options, options.name),
    name: __chunk_8.formatInputName(options.name),
    onBlur: function onBlur() {
      return options.blur(options.name);
    }
  }, isBoolean ? {
    id: __chunk_9.getInputId(options.name, options.baseId),
    "aria-describedby": __chunk_11.getMessageId(options.name, options.baseId),
    "aria-labelledby": __chunk_10.getLabelId(options.name, options.baseId)
  } : {}, htmlProps);
  htmlProps = Checkbox.useCheckbox(__chunk_2._objectSpread({}, options, {
    currentValue: currentValue,
    setValue: setValue
  }), htmlProps);
  htmlProps = useProps.unstable_useProps("useFormCheckbox", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Checkbox.useCheckbox.__keys, FormState.unstable_useFormState.__keys, ["name", "value"]);
unstable_useFormCheckbox.__keys = keys;
var unstable_FormCheckbox = createComponent.unstable_createComponent({
  as: "input",
  useHook: unstable_useFormCheckbox
});

exports.unstable_FormCheckbox = unstable_FormCheckbox;
exports.unstable_useFormCheckbox = unstable_useFormCheckbox;
