'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-6fc382c5.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../chunk-2138b837.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
var Button = require('../Button/Button.js');
require('../chunk-eb7a57a2.js');
require('../chunk-27375ea6.js');
var FormState = require('./FormState.js');
require('./utils/setAllIn.js');
var getIn = require('./utils/getIn.js');
require('./utils/setIn.js');
var __chunk_8 = require('../chunk-0ecca8fe.js');
var __chunk_9 = require('../chunk-a509fd16.js');
var __chunk_12 = require('../chunk-9cd8f724.js');

function unstable_useFormPushButton(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useFormPushButton", options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    id: __chunk_12.getPushButtonId(options.name, options.baseId),
    onClick: function onClick() {
      options.push(options.name, options.value);

      var _unstable_getIn = getIn.unstable_getIn(options.values, options.name, []),
          length = _unstable_getIn.length;

      var inputId = __chunk_9.getInputId(__chunk_8.formatInputName(options.name, "-") + "-" + length, options.baseId);
      if (!inputId) return;
      window.requestAnimationFrame(function () {
        var selector = "[id^=\"" + inputId + "\"]";
        var input = document.querySelector(selector);

        if (input) {
          input.focus();
        }
      });
    }
  }, htmlProps);
  htmlProps = Button.useButton(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useFormPushButton", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Button.useButton.__keys, FormState.unstable_useFormState.__keys, ["name", "value"]);
unstable_useFormPushButton.__keys = keys;
var unstable_FormPushButton = createComponent.unstable_createComponent({
  as: "button",
  useHook: unstable_useFormPushButton
});

exports.unstable_FormPushButton = unstable_FormPushButton;
exports.unstable_useFormPushButton = unstable_useFormPushButton;
