'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
var useCreateElement = require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-6fc382c5.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_2 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../chunk-eb7a57a2.js');
var __chunk_6 = require('../chunk-ebc3ed80.js');
require('react-dom');
var Portal = require('../Portal/Portal.js');
require('../Hidden/HiddenState.js');
require('../Hidden/Hidden.js');
require('../Dialog/Dialog.js');
require('body-scroll-lock');
require('../Dialog/DialogState.js');
require('../Rover/RoverState.js');
require('popper.js');
require('../Popover/PopoverState.js');
var Popover = require('../Popover/Popover.js');
var StaticMenu = require('./StaticMenu.js');
require('./StaticMenuState.js');
var MenuState = require('./MenuState.js');

function useMenu(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _options = __chunk_2._objectSpread({}, options, {
    unstable_autoFocusOnShow: !options.unstable_parent || options.unstable_parent.orientation !== "horizontal"
  });

  _options = useOptions.unstable_useOptions("useMenu", _options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "menu"
  }, htmlProps);
  htmlProps = StaticMenu.unstable_useStaticMenu(_options, htmlProps);
  htmlProps = Popover.usePopover(_options, htmlProps);
  htmlProps = useProps.unstable_useProps("useMenu", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Popover.usePopover.__keys, StaticMenu.unstable_useStaticMenu.__keys, MenuState.useMenuState.__keys);
useMenu.__keys = keys;
var Menu = createComponent.unstable_createComponent({
  as: "div",
  useHook: useMenu,
  useCreateElement: function useCreateElement$1(type, props, children) {
    process.env.NODE_ENV !== "production" ? __chunk_6.warning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.\nSee https://www.w3.org/TR/wai-aria-practices-1.1/#wai-aria-roles-states-and-properties-13", "Menu") : void 0;
    var element = useCreateElement.unstable_useCreateElement(type, props, children);
    return React.createElement(Portal.Portal, null, element);
  }
});

exports.Menu = Menu;
exports.useMenu = useMenu;
