'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-6fc382c5.js');
var mergeProps = require('../utils/mergeProps.js');
require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../Button/Button.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
require('../Hidden/HiddenDisclosure.js');
require('../Dialog/DialogDisclosure.js');
require('../Rover/RoverState.js');
require('popper.js');
require('../Popover/PopoverState.js');
var MenuState = require('./MenuState.js');
var PopoverDisclosure = require('../Popover/PopoverDisclosure.js');

function useMenuDisclosure(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useMenuDisclosure", options, htmlProps);
  var dir = options.placement ? options.placement.split("-")[0] : undefined;
  htmlProps = mergeProps.mergeProps({
    "aria-haspopup": "menu",
    onKeyDown: function onKeyDown(event) {
      if (options.disabled) return;
      var keyMap = {
        ArrowUp: dir === "top" || dir === "bottom" ? options.unstable_last : false,
        ArrowRight: dir === "right" && options.unstable_first,
        ArrowDown: dir === "bottom" || dir === "top" ? options.unstable_first : false,
        ArrowLeft: dir === "left" && options.unstable_first
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (typeof action === "function") {
          event.preventDefault();
          options.show();
          action();
        }
      }
    }
  }, htmlProps);
  htmlProps = PopoverDisclosure.usePopoverDisclosure(options, htmlProps);
  htmlProps = useProps.unstable_useProps("useMenuDisclosure", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(PopoverDisclosure.usePopoverDisclosure.__keys, MenuState.useMenuState.__keys);
useMenuDisclosure.__keys = keys;
var MenuDisclosure = createComponent.unstable_createComponent({
  as: "button",
  useHook: useMenuDisclosure
});

exports.MenuDisclosure = MenuDisclosure;
exports.useMenuDisclosure = useMenuDisclosure;
