'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-6fc382c5.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_2 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
require('../chunk-27375ea6.js');
require('../Rover/RoverState.js');
var Rover = require('../Rover/Rover.js');
require('popper.js');
require('../Popover/PopoverState.js');
var MenuState = require('./MenuState.js');

function useMenuItem(_ref, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _ref$unstable_focusab = _ref.unstable_focusable,
      unstable_focusable = _ref$unstable_focusab === void 0 ? true : _ref$unstable_focusab,
      options = __chunk_2._objectWithoutPropertiesLoose(_ref, ["unstable_focusable"]);

  var _options = __chunk_2._objectSpread({
    unstable_focusable: unstable_focusable
  }, options);

  _options = useOptions.unstable_useOptions("useMenuItem", _options, htmlProps);
  htmlProps = mergeProps.mergeProps({
    role: "menuitem",
    onKeyDown: function onKeyDown(event) {
      var _options2 = _options,
          parent = _options2.unstable_parent,
          hide = _options2.hide,
          placement = _options2.placement;
      if (!parent || !hide || !placement) return;

      var _placement$split = placement.split("-"),
          dir = _placement$split[0];

      var target = event.target;
      var parentIsHorizontal = parent.orientation === "horizontal";
      var isDisclosure = target.getAttribute("aria-haspopup") === "menu";
      var keyMap = {
        ArrowRight: parentIsHorizontal && !isDisclosure ? function () {
          parent.unstable_next();
          hide();
        } : dir === "left" && hide,
        ArrowLeft: parentIsHorizontal && !isDisclosure ? function () {
          parent.unstable_previous();
          hide();
        } : dir === "right" && hide
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (typeof action === "function") {
          event.preventDefault();
          action();
        }
      }
    }
  }, htmlProps);
  htmlProps = Rover.useRover(_options, htmlProps);
  htmlProps = useProps.unstable_useProps("useMenuItem", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Rover.useRover.__keys, MenuState.useMenuState.__keys);
useMenuItem.__keys = keys;
var MenuItem = createComponent.unstable_createComponent({
  as: "button",
  useHook: useMenuItem
});

exports.MenuItem = MenuItem;
exports.useMenuItem = useMenuItem;
