'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-6fc382c5.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_2 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../Button/Button.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
require('../Hidden/HiddenDisclosure.js');
require('../Dialog/DialogDisclosure.js');
require('../chunk-27375ea6.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('popper.js');
require('../Popover/PopoverState.js');
var MenuState = require('./MenuState.js');
require('../Popover/PopoverDisclosure.js');
var MenuDisclosure = require('./MenuDisclosure.js');
var MenuItem = require('./MenuItem.js');

function useKeyboardFocus(targetRef, handler, enabled) {
  var handlerRef = React.useRef(handler);
  var lastMouseDown = React.useRef();
  React.useEffect(function () {
    handlerRef.current = handler;
  });
  React.useEffect(function () {
    if (!enabled || !targetRef.current) return undefined;

    var handleFocus = function handleFocus(event) {
      if (event.target !== lastMouseDown.current) {
        handlerRef.current(event);
      }
    };

    var handleBlur = function handleBlur() {
      lastMouseDown.current = null;
    };

    var handleMouseDown = function handleMouseDown(event) {
      lastMouseDown.current = event.target;
    };

    targetRef.current.addEventListener("focus", handleFocus);
    targetRef.current.addEventListener("blur", handleBlur);
    document.addEventListener("mousedown", handleMouseDown);
    document.addEventListener("touchstart", handleMouseDown);
    return function () {
      if (targetRef.current) {
        targetRef.current.removeEventListener("focus", handleFocus);
        targetRef.current.removeEventListener("blur", handleBlur);
      }

      document.removeEventListener("mousedown", handleMouseDown);
      document.removeEventListener("touchstart", handleMouseDown);
    };
  }, []);
}

function unstable_useMenuItemDisclosure(_ref, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _ref$unstable_focusab = _ref.unstable_focusable,
      unstable_focusable = _ref$unstable_focusab === void 0 ? true : _ref$unstable_focusab,
      options = __chunk_2._objectWithoutPropertiesLoose(_ref, ["unstable_focusable"]);

  var _options = __chunk_2._objectSpread({
    unstable_focusable: unstable_focusable
  }, options);

  _options = useOptions.unstable_useOptions("useMenuItemDisclosure", _options, htmlProps);
  var ref = React.useRef(null);
  var _options2 = _options,
      parent = _options2.unstable_parent;

  if (!parent) {
    // TODO: Better error
    throw new Error("Missing parent prop");
  }

  useKeyboardFocus(ref, _options.show, parent.orientation === "horizontal" && !_options.disabled);
  React.useEffect(function () {
    if (parent.orientation !== "horizontal") return;
    var thisStop = parent.unstable_stops.find(function (stop) {
      return stop.ref.current === ref.current;
    });
    var thisIsCurrent = thisStop && thisStop.id === parent.unstable_currentId;

    if (!thisIsCurrent && _options.visible) {
      _options.hide();
    }
  }, [parent.orientation, parent.unstable_currentId, parent.unstable_stops, _options.hide]);
  htmlProps = mergeProps.mergeProps({
    ref: ref,
    onKeyDown: function onKeyDown(event) {
      if (event.key === "Escape") {
        event.preventDefault();

        _options.hide();
      }
    }
  }, htmlProps);
  htmlProps = MenuItem.useMenuItem(__chunk_2._objectSpread({}, _options, parent), htmlProps);
  htmlProps = MenuDisclosure.useMenuDisclosure(_options, htmlProps);
  htmlProps = useProps.unstable_useProps("useMenuItemDisclosure", _options, htmlProps);
  return htmlProps;
}
var keys = [].concat(MenuDisclosure.useMenuDisclosure.__keys, MenuState.useMenuState.__keys, ["stopId"]);
unstable_useMenuItemDisclosure.__keys = keys;
var unstable_MenuItemDisclosure = createComponent.unstable_createComponent({
  as: "button",
  useHook: unstable_useMenuItemDisclosure
});

exports.unstable_MenuItemDisclosure = unstable_MenuItemDisclosure;
exports.unstable_useMenuItemDisclosure = unstable_useMenuItemDisclosure;
