'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../utils/useId.js');
require('../utils/useCreateElement.js');
require('../system/SystemContext.js');
require('../chunk-6fc382c5.js');
var mergeProps = require('../utils/mergeProps.js');
var __chunk_2 = require('../chunk-37dea005.js');
var createComponent = require('../utils/createComponent.js');
require('../system/useToken.js');
var useProps = require('../system/useProps.js');
var useOptions = require('../system/useOptions.js');
require('../Box/Box.js');
require('../chunk-9263130a.js');
require('../Tabbable/Tabbable.js');
require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
require('../chunk-27375ea6.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('../Radio/RadioState.js');
var Radio = require('../Radio/Radio.js');
require('popper.js');
require('../Popover/PopoverState.js');
var MenuState = require('./MenuState.js');

function unstable_useMenuItemRadio(options, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  options = useOptions.unstable_useOptions("useMenuItemRadio", options, htmlProps);
  var currentValue = options.unstable_values[options.name];

  var setValue = function setValue(value) {
    return options.unstable_update(options.name, value);
  };

  htmlProps = mergeProps.mergeProps({
    role: "menuitemradio",
    onKeyDown: function onKeyDown(event) {
      var _options = options,
          parent = _options.unstable_parent,
          hide = _options.hide,
          placement = _options.placement;
      if (!parent || !hide || !placement) return;

      var _placement$split = placement.split("-"),
          dir = _placement$split[0];

      var parentIsHorizontal = parent.orientation === "horizontal";
      var keyMap = {
        ArrowRight: parentIsHorizontal ? function () {
          parent.unstable_next();
          hide();
        } : dir === "left" && hide,
        ArrowLeft: parentIsHorizontal ? function () {
          parent.unstable_previous();
          hide();
        } : dir === "right" && hide
      };

      if (event.key in keyMap) {
        var key = event.key;
        var action = keyMap[key];

        if (typeof action === "function") {
          event.preventDefault();
          action();
        }
      }
    }
  }, htmlProps);
  htmlProps = Radio.unstable_useRadio(__chunk_2._objectSpread({}, options, {
    currentValue: currentValue,
    setValue: setValue
  }), htmlProps);
  htmlProps = useProps.unstable_useProps("useMenuItemRadio", options, htmlProps);
  return htmlProps;
}
var keys = [].concat(Radio.unstable_useRadio.__keys, MenuState.useMenuState.__keys, ["name"]);
unstable_useMenuItemRadio.__keys = keys;
var unstable_MenuItemRadio = createComponent.unstable_createComponent({
  as: "input",
  useHook: unstable_useMenuItemRadio
});

exports.unstable_MenuItemRadio = unstable_MenuItemRadio;
exports.unstable_useMenuItemRadio = unstable_useMenuItemRadio;
