'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
require('../utils/useId.js');
var __chunk_2 = require('../chunk-37dea005.js');
var __chunk_5 = require('../chunk-eb7a57a2.js');
require('../chunk-ebc3ed80.js');
require('../Hidden/HiddenState.js');
require('../Dialog/DialogState.js');
var RoverState = require('../Rover/RoverState.js');
require('popper.js');
var PopoverState = require('../Popover/PopoverState.js');

function useMenuState(initialState, unstable_parent) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useSealedState = __chunk_5.useSealedState(initialState),
      _useSealedState$orien = _useSealedState.orientation,
      orientation = _useSealedState$orien === void 0 ? "vertical" : _useSealedState$orien,
      _useSealedState$unsta = _useSealedState.unstable_gutter,
      gutter = _useSealedState$unsta === void 0 ? 0 : _useSealedState$unsta,
      _useSealedState$unsta2 = _useSealedState.unstable_values,
      initialValues = _useSealedState$unsta2 === void 0 ? {} : _useSealedState$unsta2,
      sealed = __chunk_2._objectWithoutPropertiesLoose(_useSealedState, ["orientation", "unstable_gutter", "unstable_values"]);

  var _React$useState = React.useState(initialValues),
      values = _React$useState[0],
      setValues = _React$useState[1];

  var placement = sealed.placement || (unstable_parent && unstable_parent.orientation === "vertical" ? "right-start" : "bottom-start");
  var rover = RoverState.useRoverState(__chunk_2._objectSpread({}, sealed, {
    orientation: orientation
  }));
  var popover = PopoverState.usePopoverState(__chunk_2._objectSpread({}, sealed, {
    placement: placement,
    unstable_gutter: gutter
  }));
  React.useEffect(function () {
    if (!popover.visible) {
      rover.unstable_reset();
    }
  }, [popover.visible]);
  return __chunk_2._objectSpread({}, rover, popover, {
    unstable_parent: React.useMemo(function () {
      return unstable_parent;
    }, Object.values(unstable_parent || {})),
    unstable_values: values,
    unstable_update: React.useCallback(function (name, value) {
      setValues(function (vals) {
        var _objectSpread2;

        return __chunk_2._objectSpread({}, vals, (_objectSpread2 = {}, _objectSpread2[name] = typeof value === "function" ? value(vals) : value, _objectSpread2));
      });
    }, [])
  });
}
var keys = [].concat(RoverState.useRoverState.__keys, PopoverState.usePopoverState.__keys, ["unstable_parent", "unstable_values", "unstable_update"]);
useMenuState.__keys = keys;

exports.useMenuState = useMenuState;
