import * as React from "react";
import { unstable_TabbableOptions, unstable_TabbableProps } from "../Tabbable/Tabbable";
import { unstable_CheckboxStateReturn } from "./CheckboxState";
export declare type unstable_CheckboxOptions = unstable_TabbableOptions & Partial<unstable_CheckboxStateReturn> & {
    /**
     * Checkbox's value is going to be used when multiple checkboxes share the
     * same state. Checking a checkbox with value will add it to the state
     * array.
     */
    value?: any;
    /**
     * Checkbox's checked state. If present, it's used instead of currentValue.
     */
    checked?: boolean;
};
export declare type unstable_CheckboxProps = unstable_TabbableProps & React.InputHTMLAttributes<any>;
export declare function useCheckbox(options?: unstable_CheckboxOptions, htmlProps?: unstable_CheckboxProps): import("..").unstable_RadioProps;
export declare namespace useCheckbox {
    var __keys: ("unstable_system" | "disabled" | "unstable_focusable" | "unstable_clickKeys" | "value" | "currentValue" | "setValue" | "checked")[];
}
export declare const Checkbox: <TT extends React.ElementType<any> = "input">({ as, ...props }: import("../__utils/types").PropsWithAs<unstable_CheckboxOptions, TT>, ref: React.Ref<any>) => JSX.Element;
