import * as React from "react";
import { SealedInitialState } from "../__utils/useSealedState";
export declare type unstable_CheckboxState = {
    /**
     * Stores the state of the checkbox.
     * If checkboxes that share this state have defined a `value` prop, it's
     * going to be an array.
     * @default false
     */
    currentValue: boolean | "indeterminate" | any[];
};
export declare type unstable_CheckboxActions = {
    /**
     * Sets `currentValue`.
     */
    setValue: React.Dispatch<React.SetStateAction<unstable_CheckboxState["currentValue"]>>;
};
export declare type unstable_CheckboxInitialState = Partial<Pick<unstable_CheckboxState, "currentValue">>;
export declare type unstable_CheckboxStateReturn = unstable_CheckboxState & unstable_CheckboxActions;
/**
 * As simple as `React.useState(false)`
 */
export declare function useCheckboxState(initialState?: SealedInitialState<unstable_CheckboxInitialState>): unstable_CheckboxStateReturn;
export declare namespace useCheckboxState {
    var __keys: ("currentValue" | "setValue")[];
}
