import { SealedInitialState } from "../__utils/useSealedState";
export declare type unstable_HiddenState = {
    /**
     * Hidden element id.
     */
    unstable_hiddenId: string;
    /**
     * Whether it's visible or not.
     * @default false
     */
    visible: boolean;
};
export declare type unstable_HiddenActions = {
    /**
     * Changes the `visible` state to `true`
     */
    show: () => void;
    /**
     * Changes the `visible` state to `false`
     */
    hide: () => void;
    /**
     * Toggles the `visible` state
     */
    toggle: () => void;
};
export declare type unstable_HiddenInitialState = Partial<Pick<unstable_HiddenState, "unstable_hiddenId" | "visible">>;
export declare type unstable_HiddenStateReturn = unstable_HiddenState & unstable_HiddenActions;
export declare function useHiddenState(initialState?: SealedInitialState<unstable_HiddenInitialState>): unstable_HiddenStateReturn;
export declare namespace useHiddenState {
    var __keys: ("show" | "hide" | "unstable_hiddenId" | "visible" | "toggle")[];
}
