import * as React from "react";
import { SealedInitialState } from "../__utils/useSealedState";
import { unstable_RoverState, unstable_RoverActions, unstable_RoverInitialState } from "../Rover";
export declare type unstable_RadioState = unstable_RoverState & {
    /**
     * The `value` attribute of the current checked radio.
     */
    currentValue: any;
};
export declare type unstable_RadioActions = unstable_RoverActions & {
    /**
     * Changes the `currentValue` state.
     */
    setValue: React.Dispatch<React.SetStateAction<any>>;
};
export declare type unstable_RadioInitialState = unstable_RoverInitialState & Partial<Pick<unstable_RadioState, "currentValue">>;
export declare type unstable_RadioStateReturn = unstable_RadioState & unstable_RadioActions;
export declare function unstable_useRadioState(initialState?: SealedInitialState<unstable_RadioInitialState>): unstable_RadioStateReturn;
export declare namespace unstable_useRadioState {
    var __keys: ("orientation" | "unstable_stops" | "unstable_currentId" | "unstable_pastId" | "unstable_loop" | "unstable_register" | "unstable_unregister" | "unstable_move" | "unstable_next" | "unstable_previous" | "unstable_first" | "unstable_last" | "unstable_reset" | "unstable_orientate" | "currentValue" | "setValue")[];
}
