/// <reference types="react" />
import { unstable_BoxOptions, unstable_BoxProps } from "../Box/Box";
export declare type unstable_SeparatorOptions = unstable_BoxOptions & {
    /**
     * Separator's context orientation.
     * The actual separator's oriention will be flipped based on this prop.
     * So a `"vertical"` orientation means that the separator will have a
     * `"horizontal"` orientation.
     * @default "vertical"
     */
    orientation?: "horizontal" | "vertical";
};
export declare type unstable_SeparatorProps = unstable_BoxProps;
export declare function useSeparator({ orientation, ...options }?: unstable_SeparatorOptions, htmlProps?: unstable_SeparatorProps): import("react").HTMLAttributes<any> & import("react").RefAttributes<any>;
export declare namespace useSeparator {
    var __keys: ("unstable_system" | "orientation")[];
}
export declare const Separator: <TT extends import("react").ElementType<any> = "hr">({ as, ...props }: import("../__utils/types").PropsWithAs<unstable_SeparatorOptions, TT>, ref: import("react").Ref<any>) => JSX.Element;
